#include <iostream>
#include <algorithm>
#include <set>
using namespace std;

long long gcd(long long a,long long b)
{long long c=a%b;
 while (c){a=b;b=c;c=a%b;}
 return b;
}

class Couple
{int First,Second;
 public:
 Couple (int f=-1,int s=-1)
 {First=f;
  Second=s;   
 }
 int getFirst()const{return First;}
 int getSecond()const{return Second;}
};
class Fract
{long long num,den;
 void norm()
 {long long n;
  if (!den) return;
  if (!num) {den=1; return;}
  if (den<0){num=-num,den=-den;}   
  n=num;
  if (n<0) n=-n;
  n=gcd(n,den);
  num/=n;
  den/=n;
 }
 public:
 Fract (long long n=0,long long d=1)
 {num=n;
  den=d;
  norm();
 }
 int sign() const
 {if (num>0) return 1;
  if (num<0) return -1;
  return 0;
 }
 bool operator==(const Fract &f)const
 {return num==f.num && den==f.den;
 }
 bool operator <(const Fract &f)const
 {return num*f.den<den*f.num;
 }
 bool operator >(const Fract &f)const
 {return num*f.den>den*f.num;
 }
 Fract operator +(const Fract &f) const
 {return Fract(num*f.den+den*f.num,den*f.den);
 }
 Fract operator -(const Fract &f) const
 {return Fract(num*f.den-den*f.num,den*f.den);
 }
 Fract operator *(const Fract &f) const
 {return Fract(num*f.num,den*f.den);
 }
 Fract operator /(const Fract &f) const
 {if (!f.den) return Fract(0,0);
  return Fract(num*f.den,den*f.num);
 }
 long long getNum() const {return num;}
 long long getDen() const {return den;}
};
class Point
{bool exists;
 Fract x,y;
 public:  
 Point(){exists=false;x=y=0;}
 Point (long long a,long long b)
 {x=Fract(a,1);
  y=Fract(b,1);
  exists=true;   
 }
 Point (Fract a,Fract b)
 {x=a;
  y=b;
  exists=true;
 }
 Fract getX() const {return x;}
 Fract getY() const {return y;}
 bool operator < (const Point &p) const
 {if (x<p.x) return true;
  if (x>p.x) return false;   
  return y<p.y;
 }
 bool operator == (const Point &p) const
 {return x==p.x && y==p.y;
 }
};

//Globals
int n,k;
Point *p;

Fract orientedAreaX2(const Point &a,const Point &b,const Point &c)
{return (b.getX()-a.getX())*(c.getY()-a.getY())-(c.getX()-a.getX())*(b.getY()-a.getY());
}

bool intersect(int p1, int p2, int q1, int q2, Point &r)
{if (p1==q1||p1==q2) return false;
 if (p2==q1||p2==q2) return false;
 if (orientedAreaX2(p[p1],p[q1],p[p2]).sign()==orientedAreaX2(p[p1],p[q2],p[p2]).sign()){r=Point();return false;}
 Fract d =(p[p1].getX()-p[p2].getX())*(p[q1].getY()-p[q2].getY()) - 
          (p[p1].getY()-p[p2].getY())*(p[q1].getX()-p[q2].getX()); 
 r=Point(((p[q1].getX()-p[q2].getX())*(p[p1].getX()*p[p2].getY()-p[p1].getY()*p[p2].getX())-(p[p1].getX()-p[p2].getX())*(p[q1].getX()*p[q2].getY()-p[q1].getY()*p[q2].getX()))/d,
         ((p[q1].getY()-p[q2].getY())*(p[p1].getX()*p[p2].getY()-p[p1].getY()*p[p2].getX())-(p[p1].getY()-p[p2].getY())*(p[q1].getX()*p[q2].getY()-p[q1].getY()*p[q2].getX()))/d
        );
 return true;        
}

bool liesOn(const Point &r, int p1, int p2)
{return !orientedAreaX2(p[p1],p[p2],r).sign();
}

int main()
{ int f,t;
  long res;
  Point P;
  cin>>n>>k;
  Couple *q=new Couple[k];
  for (int i=0;i<k;i++)
  {cin>>f>>t;
   q[i]=Couple(f,t);
  }
  p=new Point[(n<<2)+1];
  set<Point> inter;
//Initialize the contour points
  for (long long i=1;i<=n+1;i++) p[i]=Point(i-1,0);
  for (long long i=n+2;i<=2*n+1;i++) p[i]=Point(n,i-n-1);
  for (long long i=2*n+2;i<=3*n+1;i++) p[i]=Point(3*n+1-i,n);
  for (long long i=3*n+2;i<=4*n;i++) p[i]=Point(0,4*n+1-i);
  res=k+1;
  for (int i=1;i<k;i++)
  {
   set<Point>::iterator it;
   for (it=inter.begin();it!=inter.end();it++)
    if (liesOn(*it,q[i].getFirst(),q[i].getSecond())) 
    {
     res++;//Another part with *it as a lowest corner
    }
   for (int j=0;j<i;j++)
   {
    if (intersect(q[i].getFirst(),q[i].getSecond(),q[j].getFirst(),q[j].getSecond(),P))
    {if (inter.find(P)==inter.end())
     {
      res++;
      inter.insert(P);
     }
    }
   }
  }
  cout<<res<<endl;
  delete[] p; 
  delete[]q;
  return 0;
}
